**AClib** is a benchmark library for instances of the algorithm configuration problem: 
given a parameterized algorithm A (the so-called target algorithm), 
a set of problem instances S (the so-called target instances), 
and a performance metric m, find a parameter setting of 
A that minimizes metric m across S. An example objective 
might be to minimize an algorithm's mean runtime.
	
The goal of AClib is to define a set of standard benchmarks 
for algorithm configuration in order to provide a solid foundation 
for empirical science in the field, much like SATlib, TSPlib, and MIPlib 
have done in their respective fields. 

AClib is hosted by Freiburg University and the University of British Columbia.

<!--- 
Detailed information and source code are available at: http://aclib.net/
!-->

## License

The code base of AClib is distributed under the GNU Public License. See COPYING for
details regarding the license. The licenses of the instance sets, target algorithms 
and configurators can be found in the corresponding READMEs
  
## Requirements

 * Python 2.7 (for the install and run script)
 * Ruby 1.9 (for wrapper scripts of target algorithms)
 * the configurators and target algorithms have further requirements, please have a look in their READMEs.
