AClib provides an install and a run script to easily add and run new scenarios.
(We only provide support for Linux based systems.)
  
#### Example

Here is a quick and easy example to test out the AClib system.
From a clean directory, execute the following commands to download AClib
and run the SMAC configurator on a scenario from the recent Configurable
SAT Solver Competition (CSSC).

    wget http://www.aclib.net/data/aclib.tar.gz
    tar xzvf aclib.tar.gz
    mkdir my_work_dir
    cd my_work_dir
    python ../aclib/src/install_scenario.py --scenario CSSC_regressiontests_riss3gExt
    python ../aclib/src/run_scenario.py --scenario CSSC_regressiontests_riss3gExt --configurator SMAC

#### Install Script

The install script provides an easy way to download new scenarios from aclib.net. 
To list all available scenarios, use:
	
    python <path to AClib root>/src/install_scenario.py --show_scenarios

To download and install a scenario, use:

    python <path to AClib root>/src/install_scenario.py --scenario <SCENARIO KEY>
    
For further options, call:
    
    python <path to AClib root>/src/install_scenario.py -h
    
Please read all messages of the install script carefully.
In some cases we are not allowed to provide all files of a scenario because of license issues.
In those cases the install script will attempt to point you to third party websites.
   
Since there are too many ways to install all kinds of target algorithms,
please check whether the provided binaries are working on your machine.
(In a future release, we will provide an automatic test).
    
#### Run Script

The run scripts provides an easy way to run a downloaded configuration scenario.
  
To run a scenario, use:
    
    python <path to AClib root>/src/run_scenario.py --scenario <SCENARIO KEY> --configurator <configurator name>
    
By default, the working directory (including generation of output files) is your current directory.
If you want to specify another directory, use:
    
    python <path to AClib root>/src/run_scenario.py --scenario <SCENARIO KEY> --configurator <configurator name> --working_directory <dir>
    
For further options, call:
    
    python <path to AClib root>/src/run_scenario.py -h

We do not recommend that you use the AClib root as your working directory. Please choose a directory external to AClib.
